int second_case() {
  st = check_region(azt_port, 4);	/*proprietary interfaces need 4 bytes */
  if (st) {
    return -EIO;
  }
  
  if ((azt_port == 0x1f0) || (azt_port == 0x170))
    SWITCH_IDE_SLAVE;	/*switch IDE interface to slave configuration */
  
  outb(POLLED, MODE_PORT);
  inb(CMD_PORT);
  inb(CMD_PORT);
  outb(ACMD_GET_VERSION, CMD_PORT);	/*Try to get version info */
  
  aztTimeOutCount = 0;
  do {
    aztIndatum = inb(STATUS_PORT);
    aztTimeOutCount++;
    if (aztTimeOutCount >= AZT_FAST_TIMEOUT)
      break;
  } while (aztIndatum & AFL_STATUS);
  
  if (inb(DATA_PORT) != AFL_OP_OK) {	/*OP_OK? If not, reset and try again */
#ifndef MODULE
    if (azt_cont != 0x79) {
      printk
	("aztcd: no AZTECH CD-ROM drive found-Try boot parameter aztcd=<BaseAddress>,0x79\n");
      return -EIO;
    }
#else
    if (0) {
    }
#endif
    else {
      printk
	("aztcd: drive reset - please wait\n");
      for (count = 0; count < 50; count++) {
	inb(STATUS_PORT);	/*removing all data from earlier tries */
	inb(DATA_PORT);
      }
      outb(POLLED, MODE_PORT);
      inb(CMD_PORT);
      inb(CMD_PORT);
      getAztStatus();	/*trap errors */
      outb(ACMD_SOFT_RESET, CMD_PORT);	/*send reset */
      STEN_LOW;
      if (inb(DATA_PORT) != AFL_OP_OK) {	/*OP_OK? */
	printk
	  ("aztcd: no AZTECH CD-ROM drive found\n");
	return -EIO;
      }
      
      for (count = 0; count < AZT_TIMEOUT;
	   count++)
	barrier();	/* Stop gcc 2.96 being smart */
      
      if ((st = getAztStatus()) == -1) {
	printk
	  ("aztcd: Drive Status Error Status=%x\n",
	   st);
	return -EIO;
      }
#ifdef AZT_DEBUG
      printk("aztcd: Status = %x\n", st);
#endif
      outb(POLLED, MODE_PORT);
      inb(CMD_PORT);
      inb(CMD_PORT);
      outb(ACMD_GET_VERSION, CMD_PORT);	/*GetVersion */
      STEN_LOW;
      OP_OK;
    }
  }
  blk_init_queue(BLK_DEFAULT_QUEUE(MAJOR_NR), DEVICE_REQUEST, &aztSpin);
  blksize_size[MAJOR_NR] = aztcd_blocksizes;
  read_ahead[MAJOR_NR] = 4;
  register_disk(NULL, mk_kdev(MAJOR_NR, 0), 1, &azt_fops, 0);
  
  request_region(azt_port, 4, "aztcd");	/*proprietary interface */ 
}
